<?xml version="1.0" encoding="iso-8859-1"?>

<xsl:stylesheet version = "1.0"
   xmlns:xsl   = "http://www.w3.org/1999/XSL/Transform"
   xmlns:mml   = "http://www.w3.org/1998/Math/MathML"
   xmlns:msxsl = "urn:schemas-microsoft-com:xslt"
>
   <!--
      Based on the ctop.xsl and pmathmlcss.xsl files from the W3 page: http://www.w3.org/Math/XSL

      Copyright David Carlisle 2001, 2002.
   -->
   
   <xsl:import href = "../components/attributes.xsl"/>

   <xsl:import href = "mathml/unknown element.xsl"/>
   <xsl:import href = "mathml/presentation.xsl"/>

   <xsl:import href = "mathml/ptrans.xsl"/>

   <xsl:import href = "mathml/content.xsl"/>

   <xsl:output method = "html"/>

   <xsl:template match = "mml:math"> <xsl:param name = "mid"><xsl:value-of select = "generate-id()"/></xsl:param>
      <xsl:variable name = "cp">p</xsl:variable>
      
      <xsl:variable name = "disp"><xsl:choose>
         <xsl:when test = "@display = 'block'">block</xsl:when>
         <xsl:otherwise>inline</xsl:otherwise>
      </xsl:choose></xsl:variable>

      <xsl:variable name = "c2p">
         <xsl:if test = "@href"><xsl:apply-templates select = "document(@href)/mml:math/*" mode = "c2p"/></xsl:if>
         <xsl:apply-templates mode = "c2p"/>
      </xsl:variable>

      <xsl:variable name = "mathml">
         <xsl:choose>
            <xsl:when test = "msxsl:node-set($c2p)/*[1][ self::mml:mrow ]">
               <xsl:apply-templates select = "msxsl:node-set($c2p)" mode = "ptrans"/>
            </xsl:when><xsl:otherwise>
               <xsl:element name = "mml:mrow">
                  <xsl:apply-templates select = "msxsl:node-set($c2p)" mode = "ptrans"/>
               </xsl:element>
            </xsl:otherwise>
         </xsl:choose>
      </xsl:variable>

      <html><head>
         <link type = "text/css" rel = "stylesheet" href = "/css/mathml.css"/>
         <link type = "text/css" rel = "stylesheet" href = "/css/default.css"/>
         <script type = "text/jscript" src = "/js/mathml.js"/>
      </head><body>
         <xsl:if test = "$cp = 'p'">
            <span>
               <xsl:call-template name = "attributes">
                  <xsl:with-param name = "style">
                     font-size: 1pc; font-family: 'Times New Roman'; display: <xsl:value-of select = "$disp"/>;
                  </xsl:with-param>
               </xsl:call-template>
               <xsl:apply-templates select = "msxsl:node-set($mathml)">
                  <xsl:with-param name = "mid"><xsl:value-of select = "$mid"/></xsl:with-param>
               </xsl:apply-templates>
            </span>
         </xsl:if><xsl:if test = "$cp = 'cw'">
            <div style = "text-align: left;"><xsl:apply-templates select = "msxsl:node-set($mathml)" mode = "write"/></div>
            <span>
               <xsl:call-template name = "attributes">
                  <xsl:with-param name = "style">
                     font-size: 1pc; font-family: 'Times New Roman'; display: <xsl:value-of select = "$disp"/>;
                  </xsl:with-param>
               </xsl:call-template>
               <xsl:apply-templates select = "msxsl:node-set($mathml)">
                  <xsl:with-param name = "mid"><xsl:value-of select = "$mid"/></xsl:with-param>
               </xsl:apply-templates>
            </span>
         </xsl:if>
      </body></html>
   </xsl:template>
</xsl:stylesheet>
