<?xml version="1.0" encoding="iso-8859-1"?>

<xsl:stylesheet version = "1.0" exclude-result-prefixes = "h"
   xmlns:xsl = "http://www.w3.org/1999/XSL/Transform"
   xmlns:mml = "http://www.w3.org/1998/Math/MathML"
   xmlns:h   = "http://www.w3.org/1999/xhtml"
>
   <h:h2>mfrac</h:h2>

   <xsl:template match = "mml:mfrac[@bevelled = 'true']"> <xsl:param name = "mid"><xsl:value-of select = "generate-id()"/></xsl:param>
      <span><xsl:call-template name = "attributes"/>
         <span style = "vertical-align: top;">
            <xsl:apply-templates select = "*[1]">
               <xsl:with-param name = "mid"><xsl:value-of select = "$mid"/></xsl:with-param>
            </xsl:apply-templates>
         </span><span style = "vertical-align: middle; font-size: 2em;">/</span><span style = "vertical-align: bottom;">
            <xsl:apply-templates select = "*[2]">
               <xsl:with-param name = "mid"><xsl:value-of select = "$mid"/></xsl:with-param>
            </xsl:apply-templates>
         </span>
      </span>
   </xsl:template>

   <xsl:template match = "mml:mfrac"> <xsl:param name = "mid"><xsl:value-of select = "generate-id()"/></xsl:param>
      <xsl:param name = "full" select = "not(ancestor::mml:mfrac)"/>

      <span id = "{$mid}{generate-id()}o"><span><xsl:call-template name = "attributes"/>
         <table id = "{$mid}{generate-id()}t" class = "mfrac">
            <xsl:if test = "$full"     ><xsl:attribute name = "style">font-size: 75%;</xsl:attribute></xsl:if>
            <xsl:if test = "not($full)"><xsl:attribute name = "style">font-size: 100%;</xsl:attribute></xsl:if>

            <tr id = "a{generate-id()}" class = "mfraca"><td class = "mfracaa" align = "center">
               <xsl:apply-templates select = "*[1]">
                  <xsl:with-param name = "mid"><xsl:value-of select = "$mid"/></xsl:with-param>
               </xsl:apply-templates>
            </td></tr><tr id = "b{generate-id()}" class = "mfracb"><td align = "center">
               <xsl:apply-templates select = "*[2]">
                  <xsl:with-param name = "mid"><xsl:value-of select = "$mid"/></xsl:with-param>
               </xsl:apply-templates>
            </td></tr>
         </table>
      </span></span>
      <xsl:if test="$full"><script>
         Math_TableInherit( &quot;<xsl:value-of select = "$mid"/><xsl:value-of select = "generate-id(.)"/>&quot;, 1 );
         if( a<xsl:value-of select = "generate-id()"/>.offsetHeight &gt; b<xsl:value-of select = "generate-id()"/>.offsetHeight )
         {
            if( b<xsl:value-of select = "generate-id()"/>.style != null )
               b<xsl:value-of select = "generate-id()"/>.style.setExpression( "height", a<xsl:value-of select = "generate-id()"/>.offsetHeight );
         }
         else
         {
            if( a<xsl:value-of select = "generate-id()"/>.style != null )
               a<xsl:value-of select = "generate-id()"/>.style.setExpression( "height", b<xsl:value-of select = "generate-id()"/>.offsetHeight );
         }
      </script></xsl:if>
   </xsl:template>
</xsl:stylesheet>
