<?xml version="1.0" encoding="iso-8859-1"?>

<xsl:stylesheet version = "1.0" exclude-result-prefixes = "h"
   xmlns:xsl = "http://www.w3.org/1999/XSL/Transform"
   xmlns:mml = "http://www.w3.org/1998/Math/MathML"
   xmlns:h   = "http://www.w3.org/1999/xhtml"
>
   <h:h2>mo</h:h2>

   <h:h2>mo left operator check</h:h2>

   <xsl:template match = "mml:mrow" mode = "mo-l" name = "moleft">
      <xsl:choose>
         <xsl:when test = "preceding-sibling::*[1][ self::mml:mo ]">true</xsl:when>
         <xsl:when test = "preceding-sibling::*[1][ self::mml:mrow ]">
            <xsl:apply-templates select = "preceding-sibling::*[1]/*[last()]" mode = "mo-le"/>
         </xsl:when>
         <xsl:when test = "preceding-sibling::*[1]">false</xsl:when>
         <xsl:otherwise><xsl:apply-templates select = "ancestor::*[1]" mode = "mo-l"/></xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <xsl:template match = "mml:mo" mode = "mo-l">true</xsl:template>
   <xsl:template match = "mml:*"  mode = "mo-l">false</xsl:template>

   <xsl:template match = "mml:mrow" mode = "mo-le">
      <xsl:choose>
         <xsl:when test = "*[last()][ self::mml:mo ]">true</xsl:when>
         <xsl:when test = "*[last()][ self::mml:mrow ]">
            <xsl:apply-templates select = "*[last()]" mode = "mo-le"/>
         </xsl:when>
         <xsl:otherwise>false</xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <xsl:template match = "mml:mo" mode = "mo-le">true</xsl:template>
   <xsl:template match = "mml:*"  mode = "mo-le">false</xsl:template>

   <h:h2>mo right operator check</h:h2>

   <xsl:template match = "mml:mrow" mode = "mo-r" name = "moright">
      <xsl:choose>
         <xsl:when test = "following-sibling::*[1][ self::mml:mo ]">true</xsl:when>
         <xsl:when test = "following-sibling::*[1][ self::mml:mrow ]">
            <xsl:apply-templates select = "following-sibling::*[1]/*[1]" mode = "mo-rb"/>
         </xsl:when>
         <xsl:when test = "following-sibling::*[1]">false</xsl:when>
         <xsl:otherwise>
            <xsl:apply-templates select = "ancestor::*[1]/following-sibling::*[1]" mode = "mo-r"/>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <xsl:template match = "mml:mo" mode = "mo-r">true</xsl:template>
   <xsl:template match = "mml:*"  mode = "mo-r">false</xsl:template>

   <xsl:template match = "mml:mrow" mode = "mo-rb">
      <xsl:choose>
         <xsl:when test = "following-sibling::*[1][ self::mml:mrow ]">
            <xsl:apply-templates select = "following-sibling::*[1]/*[1]" mode = "mo-rb"/>
         </xsl:when>
         <xsl:otherwise>false</xsl:otherwise>
      </xsl:choose>
   </xsl:template>

   <xsl:template match = "mml:mo" mode = "mo-rb">true</xsl:template>
   <xsl:template match = "mml:*"  mode = "mo-rb">false</xsl:template>

   <h:h2>mo implementation</h:h2>

   <xsl:template match = "mml:mo"> <xsl:param name = "mid"><xsl:value-of select = "generate-id()"/></xsl:param>
      <xsl:variable name = "lo">
         <xsl:choose>
            <xsl:when test = "string-length(text()) = 1"><xsl:call-template name = "moleft"/></xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
         </xsl:choose>
      </xsl:variable>
      
      <xsl:variable name = "ro">
         <xsl:choose>
            <xsl:when test = "string-length(text()) = 1"><xsl:call-template name = "moright"/></xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
         </xsl:choose>
      </xsl:variable>

      <xsl:if test = "count(*|text()) &gt; 0">
         <span id = "{$mid}{generate-id()}"><span>
            <xsl:call-template name = "attributes">
               <xsl:with-param name = "style">
                  <xsl:if test = "$lo = 'false'">padding-left: .3em;</xsl:if>
                  <xsl:if test = "$ro = 'false'">padding-right: .3em;</xsl:if>
               </xsl:with-param>
            </xsl:call-template>

            <xsl:apply-templates>
               <xsl:with-param name = "mid"><xsl:value-of select = "$mid"/></xsl:with-param>
            </xsl:apply-templates>
         </span></span>
      </xsl:if>
   </xsl:template>
</xsl:stylesheet>
