<?xml version="1.0" encoding="iso-8859-1"?>

<xsl:stylesheet version = "1.0" exclude-result-prefixes = "h x"
   xmlns:xsl = "http://www.w3.org/1999/XSL/Transform"
   xmlns:mml = "http://www.w3.org/1998/Math/MathML"
   xmlns:h   = "http://www.w3.org/1999/xhtml"
   xmlns:x   = "data:,x"
>
   <h:h2>operator dictionary</h:h2>
   <h:p>
      The following elements in the x: namespace form an implementation of an
      "Operator Dictionary" for this MathML Implementation. In the case of
      stretch operators, the element specifies the symbol parts via the latin-1
      equivalent character based on the encoding in the symbol font. It is a clear
      "failure to comply to the spec" that using latin 1 characters (or numeric
      character references) in the latin 1 range access glyphs in teh symbol font via
      font position, however most of these character parts are not in
      Unicode (until 3.2), so there is no standard way to access these characters.
   </h:p>

   <x:x x="{" m="0em"  stretch="true" top="" middle="" extend="" bottom="">{</x:x>
   <x:x x="}" m="0em"  stretch="true" top="" middle="" extend="" bottom="">{</x:x>

   <x:x x="(" m="0em"  stretch="true" top="" middle="" extend="" bottom="">(</x:x>
   <x:x x=")" m="0em"  stretch="true" top="" middle="" extend="" bottom="">)</x:x>

   <x:x x="[" m="0em"  stretch="true" top="" middle="" extend="" bottom="">[</x:x>
   <x:x x="]" m="0em"  stretch="true" top="" middle="" extend="" bottom="">]</x:x>

   <x:x x="&#x301A;" m="0em"  stretch="true" top="" middle="" extend="" bottom="">[[</x:x>
   <x:x x="&#x301B;" m="0em"  stretch="true" top="" middle="" extend="" bottom="">]]</x:x>

   <x:x x="|" m="0em"  stretch="true" top="" middle="" extend="" bottom="">|</x:x>
   <x:x x="||" m="0em"  stretch="true" top="" middle="" extend="" bottom="">||</x:x>

   <x:x x="&#x2061;" m="0em">&#xFEFF;</x:x><!--  applyfunction -->
   <x:x x="&#x2062;" m="0em">&#xFEFF;</x:x><!--  invisibletimes -->
   <x:x x="-">&#x2212;</x:x>
   <x:x x="&#x2243;"><span style="position: relative;  top: +.1em;">&#x2212;</span>&#xFEFF;<span style="position: relative; left: -.55em; top: -.2em; margin: 0em;">~</span></x:x>
   <x:x x="&#xFE38;" m="0em">_v_</x:x>

   <h:p>
      Remove these for now, as XML parser in IE6 is broken and doesn't accept plane 1 characters.
   </h:p>
   <!--
   <x:x x="&#x1D538;" v="doublestruck">A</x:x>
   <x:x x="&#x1D539;" v="doublestruck">B</x:x>
   <x:x x="&#x2102;"  v="doublestruck">C</x:x>
   <x:x x="&#x1D53B;" v="doublestruck">D</x:x>

   <x:x x="&#x1D552;" v="doublestruck">a</x:x>
   <x:x x="&#x1D553;" v="doublestruck">b</x:x>
   <x:x x="&#x1D554;" v="doublestruck">c</x:x>
   <x:x x="&#x1D555;" v="doublestruck">d</x:x>

   <x:x x="&#x1D504;" v="fraktur">A</x:x>
   <x:x x="&#x1D505;" v="fraktur">B</x:x>
   <x:x x="&#x212D;"  v="fraktur">C</x:x>
   <x:x x="&#x1D507;" v="fraktur">D</x:x>

   <x:x x="&#x1D51E;" v="fraktur">a</x:x>
   <x:x x="&#x1D51F;" v="fraktur">b</x:x>
   <x:x x="&#x1D520;" v="fraktur">c</x:x>
   <x:x x="&#x1D521;" v="fraktur">d</x:x>
   -->

   <h:p>
      Grab all of the above into a variable.
   </h:p>
   <xsl:variable name = "opdict" select = "document('')/*/x:x"/>
</xsl:stylesheet>
