<?xml version="1.0" encoding="iso-8859-1"?>

<xsl:stylesheet version = "1.0" exclude-result-prefixes = "h"
   xmlns:xsl = "http://www.w3.org/1999/XSL/Transform"
   xmlns:mml = "http://www.w3.org/1998/Math/MathML"
   xmlns:h   = "http://www.w3.org/1999/xhtml"
>
   <h:h2>Token Element Attributes</h:h2>

   <h:h3>mathsize</h:h3>

   <xsl:template match = "@mathsize[
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-size: <xsl:value-of select = "."/>;
   </xsl:template>

   <h:h3>mathcolor</h:h3>

   <xsl:template match = "@mathcolor[
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      color: <xsl:value-of select = "."/>;
   </xsl:template>

   <h:h3>mathbackground</h:h3>

   <xsl:template match = "@mathbackground[
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      background-color: <xsl:value-of select = "."/>;
   </xsl:template>

   <h:h3>mathvariant</h:h3>
   <h:p>
      This is an implementation of the mathvariant attribute. The default value is normal
      except for the [mi] element.
   </h:p>

   <xsl:template match = "@mathvariant[.='normal'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-weight: normal; font-style: normal;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='bold'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-weight: bold; font-style: upright;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='italic'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-style: italic;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='bold-italic'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-style: upright; font-weight: bold; font-style: italic;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='bold-fraktur'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-family: old english text mt; font-weight: bold;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='script'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-family: brush script mt italic;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='fraktur'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-family: old english text mt;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='sans-serif'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-family: sans-serif;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='bold-sans-serif'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-family: sans-serif; font-weight: bold;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='sans-serif-italic'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-family: sans-serif; font-style: italic;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='sans-serif-bold-italic'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-family: sans-serif; font-style: upright; font-weight: bold; font-style: italic;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='monospace'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "style">
      font-family: monospace;
   </xsl:template>

   <xsl:template match = "@mathvariant[.='bold-fraktur' or .='fraktur' or .='script'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "apply-attr">
      <xsl:attribute name="class"/>
   </xsl:template>

   <xsl:template match = "@mathvariant[.='double-struck'][
      parent::mml:mi    or parent::mml:mn     or parent::mml:mo or
      parent::mml:mtext or parent::mml:mspace or parent::mml:ms or parent::mml:mglyph
   ]" mode = "apply-attr">
      <xsl:attribute name="class">doublestruck</xsl:attribute>
   </xsl:template>
</xsl:stylesheet>
