<?xml version="1.0" encoding="iso-8859-1"?>

<xsl:stylesheet version = "1.0" exclude-result-prefixes = "h"
   xmlns:xsl = "http://www.w3.org/1999/XSL/Transform"
   xmlns:mml = "http://www.w3.org/1998/Math/MathML"
   xmlns:h   = "http://www.w3.org/1999/xhtml"
>
   <xsl:output method = "xml"/>

   <xsl:template match = "mml:*" mode = "ptrans">
      <xsl:copy><xsl:copy-of select = "@*"/>
         <xsl:apply-templates mode = "ptrans"/>
      </xsl:copy>
   </xsl:template>

   <h:p>remove any redundant mrow elements</h:p>

   <xsl:template match = "mml:mrow[count(mml:*) = 1]" mode = "ptrans">
      <xsl:apply-templates mode = "ptrans"/>
   </xsl:template>

   <h:p>convert a fence into its equivalent mo/mrow form</h:p>

   <xsl:template match = "mml:mfenced" mode = "ptrans">
      <xsl:variable name = "l"><xsl:choose>
         <xsl:when test = "@open"><xsl:value-of select = "@open"/></xsl:when>
         <xsl:otherwise>(</xsl:otherwise>
      </xsl:choose></xsl:variable>

      <xsl:variable name = "r"><xsl:choose>
         <xsl:when test = "@close"><xsl:value-of select = "@close"/></xsl:when>
         <xsl:otherwise>)</xsl:otherwise>
      </xsl:choose></xsl:variable>

      <xsl:variable name = "s"><xsl:choose>
         <xsl:when test="@sep"><xsl:call-template name = "text">
            <xsl:with-param name = "x" select = "@sep"/>
         </xsl:call-template></xsl:when>
         <xsl:otherwise>,</xsl:otherwise>
      </xsl:choose></xsl:variable>

      <xsl:element name = "mml:mrow">
         <xsl:element name = "mml:mo"><xsl:attribute name = "fence">true</xsl:attribute><xsl:value-of select = "$l"/></xsl:element>
         <xsl:element name = "mml:mrow"><xsl:for-each select = "*">
            <xsl:apply-templates select = "." mode = "ptrans"/>
            <xsl:if test = "position() != last()">
               <xsl:element name = "mml:mo"><xsl:attribute name = "seperator">true</xsl:attribute><xsl:value-of select = "$s"/></xsl:element>
            </xsl:if>
         </xsl:for-each></xsl:element>
         <xsl:element name = "mml:mo"><xsl:attribute name = "fence">true</xsl:attribute><xsl:value-of select = "$r"/></xsl:element>
      </xsl:element>
   </xsl:template>
</xsl:stylesheet>
