<?xml version="1.0"?>

<xsl:stylesheet version = "1.0"
   xmlns:xsl = "http://www.w3.org/1999/XSL/Transform"
   xmlns:mml = "http://www.w3.org/1998/Math/MathML"
   xmlns:svg = "http://www.w3.org/2000/svg"
>
   <xsl:template match = "*" mode = "display-xml">
      <html><head>
         <link type = "text/css" rel = "stylesheet" href = "/css/default.css"/>
         <title><xsl:value-of select = "@title"/></title>
      </head><body scroll = "auto">
         <xsl:apply-templates select = "." mode = "write"/>
      </body></html>
   </xsl:template>

   <xsl:template match = "comment()" mode = "write">
      <div>
         <span class = "symbol">&lt;!--</span><span class = "comment"><xsl:value-of select = "."/></span><span class = "symbol">--&gt;</span>
      </div>
   </xsl:template>

   <xsl:template match = "*[count(*|text()) = 0]" mode = "write">
      <span class = "symbol">&lt;</span><span class = "tag-name"><xsl:value-of select = "local-name(.)"/><xsl:apply-templates select = "@*" mode = "write"/></span><span class = "symbol">/&gt;</span>
   </xsl:template>

   <xsl:template match = "*[count(text()) = 1]" mode = "write">
      <div>
         <span class = "symbol">&lt;</span><span class = "tag-name"><xsl:value-of select = "local-name(.)"/><xsl:apply-templates select = "@*" mode = "write"/></span><span class = "symbol">&gt;</span>
            <xsl:apply-templates mode = "write"/>
         <span class = "symbol">&lt;/</span><span class = "tag-name"><xsl:value-of select = "local-name(.)"/></span><span class = "symbol">&gt;</span>
      </div>
   </xsl:template>

   <xsl:template match = "*" mode = "write">
      <span class = "symbol">&lt;</span><span class = "tag-name"><xsl:value-of select = "local-name(.)"/><xsl:apply-templates select = "@*" mode = "write"/></span><span class = "symbol">&gt;</span>
      <div style = "margin-left: 1pc;">
         <xsl:apply-templates mode = "write"/>
      </div>
      <span class = "symbol">&lt;/</span><span class = "tag-name"><xsl:value-of select = "local-name(.)"/></span><span class = "symbol">&gt;</span>
   </xsl:template>

   <xsl:template match = "text()" mode = "write">
      <xsl:value-of select = "."/>
   </xsl:template>

   <xsl:template match = "@*" mode = "write">
      <span class = "attribute-name">&#xA0;<xsl:value-of select = "name()"/></span><span class = "symbol"> = &quot;</span>
         <span class = "string"><xsl:value-of select = "."/></span>
      <span class = "symbol">&quot;</span>
   </xsl:template>

   <!-- MathML specific -->

   <xsl:template match = "mml:math" mode = "write">
      <span class = "symbol">&lt;</span><span class = "tag-name">math</span>
         <span class = "attribute-name">&#xA0;xmlns</span><span class = "symbol"> = &quot;</span><span class = "ns-string">http://www.w3.org/1998/Math/MathML</span><span class = "symbol">&quot;</span>
         <xsl:apply-templates select = "@*" mode = "write"/>
      <span class = "symbol">&gt;</span>
      <div style = "margin-left: 1pc;">
         <xsl:apply-templates mode = "write"/>
      </div>
      <span class = "symbol">&lt;/</span><span class = "tag-name">math</span><span class = "symbol">&gt;</span>
   </xsl:template>

   <xsl:template match = "mml:apply" mode = "write">
      <span class = "symbol">&lt;</span><span class = "tag-name"><xsl:value-of select = "local-name(.)"/><xsl:apply-templates select = "@*" mode = "write"/></span><span class = "symbol">&gt;</span>
         <xsl:if test = "count(*[1]/*|*[1]/text()) = 0"><xsl:apply-templates select = "*[1]" mode = "write"/></xsl:if>
         <div style = "margin-left: 1pc;">
            <xsl:if test = "count(*[1]/*|*[1]/text()) > 0"><xsl:apply-templates select = "*[1]" mode = "write"/></xsl:if>
            <xsl:apply-templates select = "*[position() > 1]" mode = "write"/>
         </div>
      <span class = "symbol">&lt;/</span><span class = "tag-name"><xsl:value-of select = "local-name(.)"/></span><span class = "symbol">&gt;</span>
   </xsl:template>

   <!--
   <xsl:template match = "mml:mo[count(text()) = 1]" mode = "write">
      <xsl:variable name = "lo">
         <xsl:choose>
            <xsl:when test = "string-length(text()) = 1"><xsl:call-template name = "moleft"/></xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
         </xsl:choose>
      </xsl:variable>
      
      <xsl:variable name = "ro">
         <xsl:choose>
            <xsl:when test = "string-length(text()) = 1"><xsl:call-template name = "moright"/></xsl:when>
            <xsl:otherwise>false</xsl:otherwise>
         </xsl:choose>
      </xsl:variable>

      <div>
         <span class = "symbol">&lt;</span><span class = "tag-name">mo</span>
            <xsl:apply-templates select = "@*" mode = "write"/>
            <span class = "attribute-name">&#xA0;op:left</span><span class = "symbol"> = &quot;</span>
               <span class = "string"><xsl:value-of select = "$lo"/></span>
            <span class = "symbol">&quot;</span>
            <span class = "attribute-name">&#xA0;op:right</span><span class = "symbol"> = &quot;</span>
               <span class = "string"><xsl:value-of select = "$ro"/></span>
            <span class = "symbol">&quot;</span>
         <span class = "symbol">&gt;</span>
            <xsl:apply-templates mode = "write"/>
         <span class = "symbol">&lt;/</span><span class = "tag-name">mo</span><span class = "symbol">&gt;</span>
      </div>
   </xsl:template>
   -->

   <!-- SVG specific -->

   <xsl:template match = "svg:svg" mode = "write">
      <div><span class = "symbol">&lt;?</span><span class = "tag-name">xml</span>
         <span class = "attribute-name">&#xA0;version</span><span class = "symbol"> = &quot;</span><span class = "string">1.0</span><span class = "symbol">&quot;</span>
         <span class = "attribute-name">&#xA0;standalone</span><span class = "symbol"> = &quot;</span><span class = "string">no</span><span class = "symbol">&quot;</span>
      <span class = "symbol">?&gt;</span></div>

      <div><span class = "symbol">&lt;!</span><span class = "doctype">DOCTYPE</span>
         <xsl:text> </xsl:text><span class = "tag-name">svg</span>
         <xsl:text> </xsl:text><span class = "doctype">PUBLIC</span>
         <xsl:text> </xsl:text><span class = "symbol">&quot;</span><span class = "string">-//W3C//DTD SVG 20010904//EN</span><span class = "symbol">&quot;</span>
         <xsl:text> </xsl:text><span class = "symbol">&quot;</span><span class = "string">http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd</span><span class = "symbol">&quot;&gt;</span>
      </div>

      <div>&#xA0;</div>

      <span class = "symbol">&lt;</span><span class = "tag-name">svg</span>
         <span class = "attribute-name">&#xA0;xmlns</span><span class = "symbol"> = &quot;</span><span class = "ns-string">http://www.w3.org/2000/svg</span><span class = "symbol">&quot;</span>
         <xsl:apply-templates select = "@*" mode = "write"/>
      <span class = "symbol">&gt;</span>
      <div style = "margin-left: 1pc;">
         <xsl:apply-templates mode = "write"/>
      </div>
      <span class = "symbol">&lt;/</span><span class = "tag-name">svg</span><span class = "symbol">&gt;</span>
   </xsl:template>

   <xsl:template match = "*[(count(*|text()) = 0) and self::svg:*]" mode = "write">
      <div>
         <span class = "symbol">&lt;</span><span class = "tag-name"><xsl:value-of select = "local-name(.)"/><xsl:apply-templates select = "@*" mode = "write"/></span><span class = "symbol">/&gt;</span>
      </div>
   </xsl:template>

   <!-- how do we get this working?: -->

   <xsl:template match = "@xmlns:*|@xmlns|@xml:*" mode = "write">
      <span class = "attribute-name">&#xA0;<xsl:value-of select = "name()"/></span><span class = "symbol"> = &quot;</span>
         <span class = "ns-string"><xsl:value-of select = "."/></span>
      <span class = "symbol">&quot;</span>
   </xsl:template>
</xsl:stylesheet>
